org.apache.xmlgraphics.image.codec.util

## Class ImageInputStreamSeekableStreamAdapter

- java.lang.Object
- - java.io.InputStream
  - - org.apache.xmlgraphics.image.codec.util.SeekableStream
    - - org.apache.xmlgraphics.image.codec.util.ImageInputStreamSeekableStreamAdapter

- All Implemented Interfaces:
    java.io.Closeable, java.io.DataInput, java.lang.AutoCloseable

      public class ImageInputStreamSeekableStreamAdapter
      extends SeekableStream

  A subclass of `SeekableStream` that may be used to wrap a regular `ImageInputStream`.

- - ### Field Summary

    - ### Fields inherited from class org.apache.xmlgraphics.image.codec.util.SeekableStream

      `markPos`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ImageInputStreamSeekableStreamAdapter(javax.imageio.stream.ImageInputStream stream)` Constructs a `SeekableStream` that takes its source data from a regular `ImageInputStream`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canSeekBackwards()` Returns `true` if this object supports calls to `seek(pos)` with an offset `pos` smaller than the current offset, as returned by `getFilePointer`.
    `void` | `close()`
    `long` | `getFilePointer()` Returns the current offset in this stream.
    `int` | `read()` Reads the next byte of data from the input stream.
    `int` | `read(byte[] b, int off, int len)` Reads up to `len` bytes of data from the input stream into an array of bytes.
    `void` | `seek(long pos)` Sets the offset, measured from the beginning of this stream, at which the next read occurs.

    - ### Methods inherited from class org.apache.xmlgraphics.image.codec.util.SeekableStream

      `finalize, mark, markSupported, readBoolean, readByte, readChar, readCharLE, readDouble, readDoubleLE, readFloat, readFloatLE, readFully, readFully, readInt, readIntLE, readLine, readLong, readLongLE, readShort, readShortLE, readUnsignedByte, readUnsignedInt, readUnsignedIntLE, readUnsignedShort, readUnsignedShortLE, readUTF, reset, skipBytes, wrapInputStream`

    - ### Methods inherited from class java.io.InputStream

      `available, read, skip`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ImageInputStreamSeekableStreamAdapter

          public ImageInputStreamSeekableStreamAdapter(javax.imageio.stream.ImageInputStream stream)
                                                throws java.io.IOException

      Constructs a `SeekableStream` that takes its source data from a regular `ImageInputStream`.
      Parameters:
        `stream` - the underlying ImageInputStream to use
      Throws:
        `java.io.IOException`

  - ### Method Detail

    - #### canSeekBackwards

          public boolean canSeekBackwards()

      Returns `true` if this object supports calls to `seek(pos)` with an offset `pos` smaller than the current offset, as returned by `getFilePointer`.
      Overrides:
        `canSeekBackwards` in class `SeekableStream`

    - #### getFilePointer

          public long getFilePointer()
                              throws java.io.IOException

      Returns the current offset in this stream.
      Specified by:
        `getFilePointer` in class `SeekableStream`
      Returns:
        the offset from the beginning of the stream, in bytes, at which the next read occurs.
      Throws:
        `java.io.IOException` - if an I/O error occurs.

    - #### seek

          public void seek(long pos)
                    throws java.io.IOException

      Sets the offset, measured from the beginning of this stream, at which the next read occurs.

      If `canSeekBackwards()` returns `false`, then setting `pos` to an offset smaller than the current value of `getFilePointer()` will have no effect.

      Specified by:
        `seek` in class `SeekableStream`
      Parameters:
        `pos` - the offset position, measured in bytes from the beginning of the stream, at which to set the stream pointer.
      Throws:
        `java.io.IOException` - if `pos` is less than `0` or if an I/O error occurs.

    - #### read

          public int read()
                   throws java.io.IOException

      Reads the next byte of data from the input stream. The value byte is returned as an `int` in the range `0` to `255`. If no byte is available because the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

      A subclass must provide an implementation of this method.

      Specified by:
        `read` in class `SeekableStream`
      Returns:
        the next byte of data, or `-1` if the end of the stream is reached.
      Throws:
        `java.io.IOException` - if an I/O error occurs.

    - #### read

          public int read(byte[] b,
                          int off,
                          int len)
                   throws java.io.IOException

      Reads up to `len` bytes of data from the input stream into an array of bytes. An attempt is made to read as many as `len` bytes, but a smaller number may be read, possibly zero. The number of bytes actually read is returned as an integer.

      This method blocks until input data is available, end of stream is detected, or an exception is thrown.

      If `b` is `null`, a `NullPointerException` is thrown.

      If `off` is negative, or `len` is negative, or `off+len` is greater than the length of the array `b`, then an `IndexOutOfBoundsException` is thrown.

      If `len` is zero, then no bytes are read and `0` is returned; otherwise, there is an attempt to read at least one byte. If no byte is available because the stream is at end of stream, the value `-1` is returned; otherwise, at least one byte is read and stored into `b`.

      The first byte read is stored into element `b[off]`, the next one into `b[off+1]`, and so on. The number of bytes read is, at most, equal to `len`. Let k be the number of bytes actually read; these bytes will be stored in elements `b[off]` through `b[off+`k`-1]`, leaving elements `b[off+`k`]` through `b[off+len-1]` unaffected.

      In every case, elements `b[0]` through `b[off]` and elements `b[off+len]` through `b[b.length-1]` are unaffected.

      If the first byte cannot be read for any reason other than end of stream, then an `IOException` is thrown. In particular, an `IOException` is thrown if the input stream has been closed.

      A subclass must provide an implementation of this method.

      Specified by:
        `read` in class `SeekableStream`
      Parameters:
        `b` - the buffer into which the data is read.
        `off` - the start offset in array `b` at which the data is written.
        `len` - the maximum number of bytes to read.
      Returns:
        the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
      Throws:
        `java.io.IOException` - if an I/O error occurs.

    - #### close

          public void close()
                     throws java.io.IOException

      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.InputStream`
      Throws:
        `java.io.IOException`

Copyright 1999-2025 The Apache Software Foundation. All Rights Reserved.